<!DOCTYPE HTML>
<html lang="en">
<head>
<!-- Generated by javadoc (21) -->
<title>Source code</title>
<meta name="viewport" content="width=device-width, initial-scale=1">
<meta name="description" content="source: package: org.apache.commons.cli, class: OptionBuilder">
<meta name="generator" content="javadoc/SourceToHTMLConverter">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
</head>
<body class="source-page">
<main role="main">
<div class="source-container">
<pre><span class="source-line-no">001</span><span id="line-1">/*</span>
<span class="source-line-no">002</span><span id="line-2">  Licensed to the Apache Software Foundation (ASF) under one or more</span>
<span class="source-line-no">003</span><span id="line-3">  contributor license agreements.  See the NOTICE file distributed with</span>
<span class="source-line-no">004</span><span id="line-4">  this work for additional information regarding copyright ownership.</span>
<span class="source-line-no">005</span><span id="line-5">  The ASF licenses this file to You under the Apache License, Version 2.0</span>
<span class="source-line-no">006</span><span id="line-6">  (the "License"); you may not use this file except in compliance with</span>
<span class="source-line-no">007</span><span id="line-7">  the License.  You may obtain a copy of the License at</span>
<span class="source-line-no">008</span><span id="line-8"></span>
<span class="source-line-no">009</span><span id="line-9">      http://www.apache.org/licenses/LICENSE-2.0</span>
<span class="source-line-no">010</span><span id="line-10"></span>
<span class="source-line-no">011</span><span id="line-11">  Unless required by applicable law or agreed to in writing, software</span>
<span class="source-line-no">012</span><span id="line-12">  distributed under the License is distributed on an "AS IS" BASIS,</span>
<span class="source-line-no">013</span><span id="line-13">  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.</span>
<span class="source-line-no">014</span><span id="line-14">  See the License for the specific language governing permissions and</span>
<span class="source-line-no">015</span><span id="line-15">  limitations under the License.</span>
<span class="source-line-no">016</span><span id="line-16"> */</span>
<span class="source-line-no">017</span><span id="line-17"></span>
<span class="source-line-no">018</span><span id="line-18">package org.apache.commons.cli;</span>
<span class="source-line-no">019</span><span id="line-19"></span>
<span class="source-line-no">020</span><span id="line-20">/**</span>
<span class="source-line-no">021</span><span id="line-21"> * OptionBuilder allows the user to create Options using descriptive methods.</span>
<span class="source-line-no">022</span><span id="line-22"> * &lt;p&gt;</span>
<span class="source-line-no">023</span><span id="line-23"> * Details on the Builder pattern can be found at</span>
<span class="source-line-no">024</span><span id="line-24"> * &lt;a href="http://c2.com/cgi-bin/wiki?BuilderPattern"&gt;http://c2.com/cgi-bin/wiki?BuilderPattern&lt;/a&gt;.</span>
<span class="source-line-no">025</span><span id="line-25"> * &lt;p&gt;</span>
<span class="source-line-no">026</span><span id="line-26"> * This class is NOT thread safe. See &lt;a href="https://issues.apache.org/jira/browse/CLI-209"&gt;CLI-209&lt;/a&gt;</span>
<span class="source-line-no">027</span><span id="line-27"> *</span>
<span class="source-line-no">028</span><span id="line-28"> * @since 1.0</span>
<span class="source-line-no">029</span><span id="line-29"> * @deprecated since 1.3, use {@link Option#builder(String)} instead</span>
<span class="source-line-no">030</span><span id="line-30"> */</span>
<span class="source-line-no">031</span><span id="line-31">@Deprecated</span>
<span class="source-line-no">032</span><span id="line-32">public final class OptionBuilder {</span>
<span class="source-line-no">033</span><span id="line-33"></span>
<span class="source-line-no">034</span><span id="line-34">    /** Long option */</span>
<span class="source-line-no">035</span><span id="line-35">    private static String longOption;</span>
<span class="source-line-no">036</span><span id="line-36"></span>
<span class="source-line-no">037</span><span id="line-37">    /** Option description */</span>
<span class="source-line-no">038</span><span id="line-38">    private static String description;</span>
<span class="source-line-no">039</span><span id="line-39"></span>
<span class="source-line-no">040</span><span id="line-40">    /** Argument name */</span>
<span class="source-line-no">041</span><span id="line-41">    private static String argName;</span>
<span class="source-line-no">042</span><span id="line-42"></span>
<span class="source-line-no">043</span><span id="line-43">    /** Is required? */</span>
<span class="source-line-no">044</span><span id="line-44">    private static boolean required;</span>
<span class="source-line-no">045</span><span id="line-45"></span>
<span class="source-line-no">046</span><span id="line-46">    /** The number of arguments */</span>
<span class="source-line-no">047</span><span id="line-47">    private static int argCount = Option.UNINITIALIZED;</span>
<span class="source-line-no">048</span><span id="line-48"></span>
<span class="source-line-no">049</span><span id="line-49">    /** Option type */</span>
<span class="source-line-no">050</span><span id="line-50">    private static Class&lt;?&gt; type;</span>
<span class="source-line-no">051</span><span id="line-51"></span>
<span class="source-line-no">052</span><span id="line-52">    /** Option can have an optional argument value */</span>
<span class="source-line-no">053</span><span id="line-53">    private static boolean optionalArg;</span>
<span class="source-line-no">054</span><span id="line-54"></span>
<span class="source-line-no">055</span><span id="line-55">    /** Value separator for argument value */</span>
<span class="source-line-no">056</span><span id="line-56">    private static char valueSeparator;</span>
<span class="source-line-no">057</span><span id="line-57"></span>
<span class="source-line-no">058</span><span id="line-58">    /** Option builder instance */</span>
<span class="source-line-no">059</span><span id="line-59">    private static final OptionBuilder INSTANCE = new OptionBuilder();</span>
<span class="source-line-no">060</span><span id="line-60"></span>
<span class="source-line-no">061</span><span id="line-61">    static {</span>
<span class="source-line-no">062</span><span id="line-62">        // ensure the consistency of the initial values</span>
<span class="source-line-no">063</span><span id="line-63">        reset();</span>
<span class="source-line-no">064</span><span id="line-64">    }</span>
<span class="source-line-no">065</span><span id="line-65"></span>
<span class="source-line-no">066</span><span id="line-66">    /**</span>
<span class="source-line-no">067</span><span id="line-67">     * Creates an Option using the current settings</span>
<span class="source-line-no">068</span><span id="line-68">     *</span>
<span class="source-line-no">069</span><span id="line-69">     * @return the Option instance</span>
<span class="source-line-no">070</span><span id="line-70">     * @throws IllegalArgumentException if {@code longOpt} has not been set.</span>
<span class="source-line-no">071</span><span id="line-71">     */</span>
<span class="source-line-no">072</span><span id="line-72">    public static Option create() throws IllegalArgumentException {</span>
<span class="source-line-no">073</span><span id="line-73">        if (longOption == null) {</span>
<span class="source-line-no">074</span><span id="line-74">            OptionBuilder.reset();</span>
<span class="source-line-no">075</span><span id="line-75">            throw new IllegalArgumentException("must specify longopt");</span>
<span class="source-line-no">076</span><span id="line-76">        }</span>
<span class="source-line-no">077</span><span id="line-77"></span>
<span class="source-line-no">078</span><span id="line-78">        return create(null);</span>
<span class="source-line-no">079</span><span id="line-79">    }</span>
<span class="source-line-no">080</span><span id="line-80"></span>
<span class="source-line-no">081</span><span id="line-81">    /**</span>
<span class="source-line-no">082</span><span id="line-82">     * Creates an Option using the current settings and with the specified Option {@code char}.</span>
<span class="source-line-no">083</span><span id="line-83">     *</span>
<span class="source-line-no">084</span><span id="line-84">     * @param opt the character representation of the Option</span>
<span class="source-line-no">085</span><span id="line-85">     * @return the Option instance</span>
<span class="source-line-no">086</span><span id="line-86">     * @throws IllegalArgumentException if {@code opt} is not a valid character. See Option.</span>
<span class="source-line-no">087</span><span id="line-87">     */</span>
<span class="source-line-no">088</span><span id="line-88">    public static Option create(final char opt) throws IllegalArgumentException {</span>
<span class="source-line-no">089</span><span id="line-89">        return create(String.valueOf(opt));</span>
<span class="source-line-no">090</span><span id="line-90">    }</span>
<span class="source-line-no">091</span><span id="line-91"></span>
<span class="source-line-no">092</span><span id="line-92">    /**</span>
<span class="source-line-no">093</span><span id="line-93">     * Creates an Option using the current settings and with the specified Option {@code char}.</span>
<span class="source-line-no">094</span><span id="line-94">     *</span>
<span class="source-line-no">095</span><span id="line-95">     * @param opt the {@code java.lang.String} representation of the Option</span>
<span class="source-line-no">096</span><span id="line-96">     * @return the Option instance</span>
<span class="source-line-no">097</span><span id="line-97">     * @throws IllegalArgumentException if {@code opt} is not a valid character. See Option.</span>
<span class="source-line-no">098</span><span id="line-98">     */</span>
<span class="source-line-no">099</span><span id="line-99">    public static Option create(final String opt) throws IllegalArgumentException {</span>
<span class="source-line-no">100</span><span id="line-100">        Option option;</span>
<span class="source-line-no">101</span><span id="line-101">        try {</span>
<span class="source-line-no">102</span><span id="line-102">            // create the option</span>
<span class="source-line-no">103</span><span id="line-103">            option = new Option(opt, description);</span>
<span class="source-line-no">104</span><span id="line-104"></span>
<span class="source-line-no">105</span><span id="line-105">            // set the option properties</span>
<span class="source-line-no">106</span><span id="line-106">            option.setLongOpt(longOption);</span>
<span class="source-line-no">107</span><span id="line-107">            option.setRequired(required);</span>
<span class="source-line-no">108</span><span id="line-108">            option.setOptionalArg(optionalArg);</span>
<span class="source-line-no">109</span><span id="line-109">            option.setArgs(argCount);</span>
<span class="source-line-no">110</span><span id="line-110">            option.setType(type);</span>
<span class="source-line-no">111</span><span id="line-111">            option.setValueSeparator(valueSeparator);</span>
<span class="source-line-no">112</span><span id="line-112">            option.setArgName(argName);</span>
<span class="source-line-no">113</span><span id="line-113">        } finally {</span>
<span class="source-line-no">114</span><span id="line-114">            // reset the OptionBuilder properties</span>
<span class="source-line-no">115</span><span id="line-115">            OptionBuilder.reset();</span>
<span class="source-line-no">116</span><span id="line-116">        }</span>
<span class="source-line-no">117</span><span id="line-117"></span>
<span class="source-line-no">118</span><span id="line-118">        // return the Option instance</span>
<span class="source-line-no">119</span><span id="line-119">        return option;</span>
<span class="source-line-no">120</span><span id="line-120">    }</span>
<span class="source-line-no">121</span><span id="line-121"></span>
<span class="source-line-no">122</span><span id="line-122">    /**</span>
<span class="source-line-no">123</span><span id="line-123">     * The next Option created will require an argument value.</span>
<span class="source-line-no">124</span><span id="line-124">     *</span>
<span class="source-line-no">125</span><span id="line-125">     * @return the OptionBuilder instance</span>
<span class="source-line-no">126</span><span id="line-126">     */</span>
<span class="source-line-no">127</span><span id="line-127">    public static OptionBuilder hasArg() {</span>
<span class="source-line-no">128</span><span id="line-128">        OptionBuilder.argCount = 1;</span>
<span class="source-line-no">129</span><span id="line-129"></span>
<span class="source-line-no">130</span><span id="line-130">        return INSTANCE;</span>
<span class="source-line-no">131</span><span id="line-131">    }</span>
<span class="source-line-no">132</span><span id="line-132"></span>
<span class="source-line-no">133</span><span id="line-133">    /**</span>
<span class="source-line-no">134</span><span id="line-134">     * The next Option created will require an argument value if {@code hasArg} is true.</span>
<span class="source-line-no">135</span><span id="line-135">     *</span>
<span class="source-line-no">136</span><span id="line-136">     * @param hasArg if true then the Option has an argument value</span>
<span class="source-line-no">137</span><span id="line-137">     * @return the OptionBuilder instance</span>
<span class="source-line-no">138</span><span id="line-138">     */</span>
<span class="source-line-no">139</span><span id="line-139">    public static OptionBuilder hasArg(final boolean hasArg) {</span>
<span class="source-line-no">140</span><span id="line-140">        OptionBuilder.argCount = hasArg ? 1 : Option.UNINITIALIZED;</span>
<span class="source-line-no">141</span><span id="line-141"></span>
<span class="source-line-no">142</span><span id="line-142">        return INSTANCE;</span>
<span class="source-line-no">143</span><span id="line-143">    }</span>
<span class="source-line-no">144</span><span id="line-144"></span>
<span class="source-line-no">145</span><span id="line-145">    /**</span>
<span class="source-line-no">146</span><span id="line-146">     * The next Option created can have unlimited argument values.</span>
<span class="source-line-no">147</span><span id="line-147">     *</span>
<span class="source-line-no">148</span><span id="line-148">     * @return the OptionBuilder instance</span>
<span class="source-line-no">149</span><span id="line-149">     */</span>
<span class="source-line-no">150</span><span id="line-150">    public static OptionBuilder hasArgs() {</span>
<span class="source-line-no">151</span><span id="line-151">        OptionBuilder.argCount = Option.UNLIMITED_VALUES;</span>
<span class="source-line-no">152</span><span id="line-152"></span>
<span class="source-line-no">153</span><span id="line-153">        return INSTANCE;</span>
<span class="source-line-no">154</span><span id="line-154">    }</span>
<span class="source-line-no">155</span><span id="line-155"></span>
<span class="source-line-no">156</span><span id="line-156">    /**</span>
<span class="source-line-no">157</span><span id="line-157">     * The next Option created can have {@code num} argument values.</span>
<span class="source-line-no">158</span><span id="line-158">     *</span>
<span class="source-line-no">159</span><span id="line-159">     * @param num the number of args that the option can have</span>
<span class="source-line-no">160</span><span id="line-160">     * @return the OptionBuilder instance</span>
<span class="source-line-no">161</span><span id="line-161">     */</span>
<span class="source-line-no">162</span><span id="line-162">    public static OptionBuilder hasArgs(final int num) {</span>
<span class="source-line-no">163</span><span id="line-163">        OptionBuilder.argCount = num;</span>
<span class="source-line-no">164</span><span id="line-164"></span>
<span class="source-line-no">165</span><span id="line-165">        return INSTANCE;</span>
<span class="source-line-no">166</span><span id="line-166">    }</span>
<span class="source-line-no">167</span><span id="line-167"></span>
<span class="source-line-no">168</span><span id="line-168">    /**</span>
<span class="source-line-no">169</span><span id="line-169">     * The next Option can have an optional argument.</span>
<span class="source-line-no">170</span><span id="line-170">     *</span>
<span class="source-line-no">171</span><span id="line-171">     * @return the OptionBuilder instance</span>
<span class="source-line-no">172</span><span id="line-172">     */</span>
<span class="source-line-no">173</span><span id="line-173">    public static OptionBuilder hasOptionalArg() {</span>
<span class="source-line-no">174</span><span id="line-174">        OptionBuilder.argCount = 1;</span>
<span class="source-line-no">175</span><span id="line-175">        OptionBuilder.optionalArg = true;</span>
<span class="source-line-no">176</span><span id="line-176"></span>
<span class="source-line-no">177</span><span id="line-177">        return INSTANCE;</span>
<span class="source-line-no">178</span><span id="line-178">    }</span>
<span class="source-line-no">179</span><span id="line-179"></span>
<span class="source-line-no">180</span><span id="line-180">    /**</span>
<span class="source-line-no">181</span><span id="line-181">     * The next Option can have an unlimited number of optional arguments.</span>
<span class="source-line-no">182</span><span id="line-182">     *</span>
<span class="source-line-no">183</span><span id="line-183">     * @return the OptionBuilder instance</span>
<span class="source-line-no">184</span><span id="line-184">     */</span>
<span class="source-line-no">185</span><span id="line-185">    public static OptionBuilder hasOptionalArgs() {</span>
<span class="source-line-no">186</span><span id="line-186">        OptionBuilder.argCount = Option.UNLIMITED_VALUES;</span>
<span class="source-line-no">187</span><span id="line-187">        OptionBuilder.optionalArg = true;</span>
<span class="source-line-no">188</span><span id="line-188"></span>
<span class="source-line-no">189</span><span id="line-189">        return INSTANCE;</span>
<span class="source-line-no">190</span><span id="line-190">    }</span>
<span class="source-line-no">191</span><span id="line-191"></span>
<span class="source-line-no">192</span><span id="line-192">    /**</span>
<span class="source-line-no">193</span><span id="line-193">     * The next Option can have the specified number of optional arguments.</span>
<span class="source-line-no">194</span><span id="line-194">     *</span>
<span class="source-line-no">195</span><span id="line-195">     * @param numArgs - the maximum number of optional arguments the next Option created can have.</span>
<span class="source-line-no">196</span><span id="line-196">     * @return the OptionBuilder instance</span>
<span class="source-line-no">197</span><span id="line-197">     */</span>
<span class="source-line-no">198</span><span id="line-198">    public static OptionBuilder hasOptionalArgs(final int numArgs) {</span>
<span class="source-line-no">199</span><span id="line-199">        OptionBuilder.argCount = numArgs;</span>
<span class="source-line-no">200</span><span id="line-200">        OptionBuilder.optionalArg = true;</span>
<span class="source-line-no">201</span><span id="line-201"></span>
<span class="source-line-no">202</span><span id="line-202">        return INSTANCE;</span>
<span class="source-line-no">203</span><span id="line-203">    }</span>
<span class="source-line-no">204</span><span id="line-204"></span>
<span class="source-line-no">205</span><span id="line-205">    /**</span>
<span class="source-line-no">206</span><span id="line-206">     * The next Option created will be required.</span>
<span class="source-line-no">207</span><span id="line-207">     *</span>
<span class="source-line-no">208</span><span id="line-208">     * @return the OptionBuilder instance</span>
<span class="source-line-no">209</span><span id="line-209">     */</span>
<span class="source-line-no">210</span><span id="line-210">    public static OptionBuilder isRequired() {</span>
<span class="source-line-no">211</span><span id="line-211">        OptionBuilder.required = true;</span>
<span class="source-line-no">212</span><span id="line-212"></span>
<span class="source-line-no">213</span><span id="line-213">        return INSTANCE;</span>
<span class="source-line-no">214</span><span id="line-214">    }</span>
<span class="source-line-no">215</span><span id="line-215"></span>
<span class="source-line-no">216</span><span id="line-216">    /**</span>
<span class="source-line-no">217</span><span id="line-217">     * The next Option created will be required if {@code required} is true.</span>
<span class="source-line-no">218</span><span id="line-218">     *</span>
<span class="source-line-no">219</span><span id="line-219">     * @param newRequired if true then the Option is required</span>
<span class="source-line-no">220</span><span id="line-220">     * @return the OptionBuilder instance</span>
<span class="source-line-no">221</span><span id="line-221">     */</span>
<span class="source-line-no">222</span><span id="line-222">    public static OptionBuilder isRequired(final boolean newRequired) {</span>
<span class="source-line-no">223</span><span id="line-223">        OptionBuilder.required = newRequired;</span>
<span class="source-line-no">224</span><span id="line-224"></span>
<span class="source-line-no">225</span><span id="line-225">        return INSTANCE;</span>
<span class="source-line-no">226</span><span id="line-226">    }</span>
<span class="source-line-no">227</span><span id="line-227"></span>
<span class="source-line-no">228</span><span id="line-228">    /**</span>
<span class="source-line-no">229</span><span id="line-229">     * Resets the member variables to their default values.</span>
<span class="source-line-no">230</span><span id="line-230">     */</span>
<span class="source-line-no">231</span><span id="line-231">    private static void reset() {</span>
<span class="source-line-no">232</span><span id="line-232">        description = null;</span>
<span class="source-line-no">233</span><span id="line-233">        argName = null;</span>
<span class="source-line-no">234</span><span id="line-234">        longOption = null;</span>
<span class="source-line-no">235</span><span id="line-235">        type = String.class;</span>
<span class="source-line-no">236</span><span id="line-236">        required = false;</span>
<span class="source-line-no">237</span><span id="line-237">        argCount = Option.UNINITIALIZED;</span>
<span class="source-line-no">238</span><span id="line-238">        optionalArg = false;</span>
<span class="source-line-no">239</span><span id="line-239">        valueSeparator = (char) 0;</span>
<span class="source-line-no">240</span><span id="line-240">    }</span>
<span class="source-line-no">241</span><span id="line-241"></span>
<span class="source-line-no">242</span><span id="line-242">    /**</span>
<span class="source-line-no">243</span><span id="line-243">     * The next Option created will have the specified argument value name.</span>
<span class="source-line-no">244</span><span id="line-244">     *</span>
<span class="source-line-no">245</span><span id="line-245">     * @param name the name for the argument value</span>
<span class="source-line-no">246</span><span id="line-246">     * @return the OptionBuilder instance</span>
<span class="source-line-no">247</span><span id="line-247">     */</span>
<span class="source-line-no">248</span><span id="line-248">    public static OptionBuilder withArgName(final String name) {</span>
<span class="source-line-no">249</span><span id="line-249">        OptionBuilder.argName = name;</span>
<span class="source-line-no">250</span><span id="line-250"></span>
<span class="source-line-no">251</span><span id="line-251">        return INSTANCE;</span>
<span class="source-line-no">252</span><span id="line-252">    }</span>
<span class="source-line-no">253</span><span id="line-253"></span>
<span class="source-line-no">254</span><span id="line-254">    /**</span>
<span class="source-line-no">255</span><span id="line-255">     * The next Option created will have the specified description</span>
<span class="source-line-no">256</span><span id="line-256">     *</span>
<span class="source-line-no">257</span><span id="line-257">     * @param newDescription a description of the Option's purpose</span>
<span class="source-line-no">258</span><span id="line-258">     * @return the OptionBuilder instance</span>
<span class="source-line-no">259</span><span id="line-259">     */</span>
<span class="source-line-no">260</span><span id="line-260">    public static OptionBuilder withDescription(final String newDescription) {</span>
<span class="source-line-no">261</span><span id="line-261">        OptionBuilder.description = newDescription;</span>
<span class="source-line-no">262</span><span id="line-262"></span>
<span class="source-line-no">263</span><span id="line-263">        return INSTANCE;</span>
<span class="source-line-no">264</span><span id="line-264">    }</span>
<span class="source-line-no">265</span><span id="line-265"></span>
<span class="source-line-no">266</span><span id="line-266">    /**</span>
<span class="source-line-no">267</span><span id="line-267">     * The next Option created will have the following long option value.</span>
<span class="source-line-no">268</span><span id="line-268">     *</span>
<span class="source-line-no">269</span><span id="line-269">     * @param newLongopt the long option value</span>
<span class="source-line-no">270</span><span id="line-270">     * @return the OptionBuilder instance</span>
<span class="source-line-no">271</span><span id="line-271">     */</span>
<span class="source-line-no">272</span><span id="line-272">    public static OptionBuilder withLongOpt(final String newLongopt) {</span>
<span class="source-line-no">273</span><span id="line-273">        OptionBuilder.longOption = newLongopt;</span>
<span class="source-line-no">274</span><span id="line-274"></span>
<span class="source-line-no">275</span><span id="line-275">        return INSTANCE;</span>
<span class="source-line-no">276</span><span id="line-276">    }</span>
<span class="source-line-no">277</span><span id="line-277"></span>
<span class="source-line-no">278</span><span id="line-278">    /**</span>
<span class="source-line-no">279</span><span id="line-279">     * The next Option created will have a value that will be an instance of {@code type}.</span>
<span class="source-line-no">280</span><span id="line-280">     *</span>
<span class="source-line-no">281</span><span id="line-281">     * @param newType the type of the Options argument value</span>
<span class="source-line-no">282</span><span id="line-282">     * @return the OptionBuilder instance</span>
<span class="source-line-no">283</span><span id="line-283">     * @since 1.3</span>
<span class="source-line-no">284</span><span id="line-284">     */</span>
<span class="source-line-no">285</span><span id="line-285">    public static OptionBuilder withType(final Class&lt;?&gt; newType) {</span>
<span class="source-line-no">286</span><span id="line-286">        OptionBuilder.type = newType;</span>
<span class="source-line-no">287</span><span id="line-287"></span>
<span class="source-line-no">288</span><span id="line-288">        return INSTANCE;</span>
<span class="source-line-no">289</span><span id="line-289">    }</span>
<span class="source-line-no">290</span><span id="line-290"></span>
<span class="source-line-no">291</span><span id="line-291">    /**</span>
<span class="source-line-no">292</span><span id="line-292">     * The next Option created will have a value that will be an instance of {@code type}.</span>
<span class="source-line-no">293</span><span id="line-293">     * &lt;p&gt;</span>
<span class="source-line-no">294</span><span id="line-294">     * &lt;b&gt;Note:&lt;/b&gt; this method is kept for binary compatibility and the input type is supposed to be a {@link Class}</span>
<span class="source-line-no">295</span><span id="line-295">     * object.</span>
<span class="source-line-no">296</span><span id="line-296">     *</span>
<span class="source-line-no">297</span><span id="line-297">     * @param newType the type of the Options argument value</span>
<span class="source-line-no">298</span><span id="line-298">     * @return the OptionBuilder instance</span>
<span class="source-line-no">299</span><span id="line-299">     * @deprecated since 1.3, use {@link #withType(Class)} instead</span>
<span class="source-line-no">300</span><span id="line-300">     */</span>
<span class="source-line-no">301</span><span id="line-301">    @Deprecated</span>
<span class="source-line-no">302</span><span id="line-302">    public static OptionBuilder withType(final Object newType) {</span>
<span class="source-line-no">303</span><span id="line-303">        return withType((Class&lt;?&gt;) newType);</span>
<span class="source-line-no">304</span><span id="line-304">    }</span>
<span class="source-line-no">305</span><span id="line-305"></span>
<span class="source-line-no">306</span><span id="line-306">    /**</span>
<span class="source-line-no">307</span><span id="line-307">     * The next Option created uses '{@code =}' as a means to separate argument values.</span>
<span class="source-line-no">308</span><span id="line-308">     *</span>
<span class="source-line-no">309</span><span id="line-309">     * &lt;b&gt;Example:&lt;/b&gt;</span>
<span class="source-line-no">310</span><span id="line-310">     *</span>
<span class="source-line-no">311</span><span id="line-311">     * &lt;pre&gt;</span>
<span class="source-line-no">312</span><span id="line-312">     * Option opt = OptionBuilder.withValueSeparator().create('D');</span>
<span class="source-line-no">313</span><span id="line-313">     *</span>
<span class="source-line-no">314</span><span id="line-314">     * CommandLine line = parser.parse(args);</span>
<span class="source-line-no">315</span><span id="line-315">     * String propertyName = opt.getValue(0);</span>
<span class="source-line-no">316</span><span id="line-316">     * String propertyValue = opt.getValue(1);</span>
<span class="source-line-no">317</span><span id="line-317">     * &lt;/pre&gt;</span>
<span class="source-line-no">318</span><span id="line-318">     *</span>
<span class="source-line-no">319</span><span id="line-319">     * @return the OptionBuilder instance</span>
<span class="source-line-no">320</span><span id="line-320">     */</span>
<span class="source-line-no">321</span><span id="line-321">    public static OptionBuilder withValueSeparator() {</span>
<span class="source-line-no">322</span><span id="line-322">        OptionBuilder.valueSeparator = '=';</span>
<span class="source-line-no">323</span><span id="line-323"></span>
<span class="source-line-no">324</span><span id="line-324">        return INSTANCE;</span>
<span class="source-line-no">325</span><span id="line-325">    }</span>
<span class="source-line-no">326</span><span id="line-326"></span>
<span class="source-line-no">327</span><span id="line-327">    /**</span>
<span class="source-line-no">328</span><span id="line-328">     * The next Option created uses {@code sep} as a means to separate argument values.</span>
<span class="source-line-no">329</span><span id="line-329">     * &lt;p&gt;</span>
<span class="source-line-no">330</span><span id="line-330">     * &lt;b&gt;Example:&lt;/b&gt;</span>
<span class="source-line-no">331</span><span id="line-331">     *</span>
<span class="source-line-no">332</span><span id="line-332">     * &lt;pre&gt;</span>
<span class="source-line-no">333</span><span id="line-333">     * Option opt = OptionBuilder.withValueSeparator('=').create('D');</span>
<span class="source-line-no">334</span><span id="line-334">     *</span>
<span class="source-line-no">335</span><span id="line-335">     * String args = "-Dkey=value";</span>
<span class="source-line-no">336</span><span id="line-336">     * CommandLine line = parser.parse(args);</span>
<span class="source-line-no">337</span><span id="line-337">     * String propertyName = opt.getValue(0); // will be "key"</span>
<span class="source-line-no">338</span><span id="line-338">     * String propertyValue = opt.getValue(1); // will be "value"</span>
<span class="source-line-no">339</span><span id="line-339">     * &lt;/pre&gt;</span>
<span class="source-line-no">340</span><span id="line-340">     *</span>
<span class="source-line-no">341</span><span id="line-341">     * @param sep The value separator to be used for the argument values.</span>
<span class="source-line-no">342</span><span id="line-342">     *</span>
<span class="source-line-no">343</span><span id="line-343">     * @return the OptionBuilder instance</span>
<span class="source-line-no">344</span><span id="line-344">     */</span>
<span class="source-line-no">345</span><span id="line-345">    public static OptionBuilder withValueSeparator(final char sep) {</span>
<span class="source-line-no">346</span><span id="line-346">        OptionBuilder.valueSeparator = sep;</span>
<span class="source-line-no">347</span><span id="line-347"></span>
<span class="source-line-no">348</span><span id="line-348">        return INSTANCE;</span>
<span class="source-line-no">349</span><span id="line-349">    }</span>
<span class="source-line-no">350</span><span id="line-350"></span>
<span class="source-line-no">351</span><span id="line-351">    /**</span>
<span class="source-line-no">352</span><span id="line-352">     * private constructor to prevent instances being created</span>
<span class="source-line-no">353</span><span id="line-353">     */</span>
<span class="source-line-no">354</span><span id="line-354">    private OptionBuilder() {</span>
<span class="source-line-no">355</span><span id="line-355">        // hide the constructor</span>
<span class="source-line-no">356</span><span id="line-356">    }</span>
<span class="source-line-no">357</span><span id="line-357">}</span>




























































</pre>
</div>
</main>
</body>
</html>
